Index: FOIAVistA/tag/r/IMAGING-MAG-ZMAG/MAGGTU31.m
===================================================================
--- FOIAVistA/trunk/r/IMAGING-MAG-ZMAG/MAGGTU31.m	(revision 631)
+++ FOIAVistA/tag/r/IMAGING-MAG-ZMAG/MAGGTU31.m	(revision 636)
@@ -1,4 +1,4 @@
 MAGGTU31 ;WOIFO/GEK - Silent calls for Imaging ; [ 06/20/2001 08:57 ]
- ;;3.0;IMAGING;**46,59**;Nov 27, 2007;Build 20
+ ;;3.0;IMAGING;**46**;16-February-2007;;Build 1023
  ;; Per VHA Directive 2004-038, this routine should not be modified.
  ;; +---------------------------------------------------------------+
@@ -9,5 +9,4 @@
  ;; | Development Office of the Department of Veterans Affairs,     |
  ;; | telephone (301) 734-0100.                                     |
- ;; |                                                               |
  ;; | The Food and Drug Administration classifies this software as  |
  ;; | a medical device.  As such, it may not be changed in any way. |
@@ -62,98 +61,2 @@
  I MAGMED S J=J+1,MAGK(J)="MAGCAP MED"
  Q
-GETINFO(MAGRY,IEN) ; RPC [MAG4 GET IMAGE INFO]Called from MAGGTU3
- ; Call (3.0p8) to get information on 1 image 
- ; and Display in the Image Information Window
- N Y,J,JI,I,CT,IENC,FLAGS,SNGRP,Z,M40,T,QACHK,OBJTYP,VAL,LBL
- S I=0,CT=0
- S MAGRY(CT)="Image ID#:      "_IEN
- I $D(^MAG(2005.1,IEN)) D  Q
- . S CT=CT+1,MAGRY(CT)="    STATUS:  "_"HAS BEEN DELETED. !!"
- . S CT=CT+1,MAGRY(CT)="Deleted By: "_$$GET1^DIQ(2005.1,IEN,30,"E")
- . S CT=CT+1,MAGRY(CT)="    Reason: "_$$GET1^DIQ(2005.1,IEN,30.2,"E")
- . S CT=CT+1,MAGRY(CT)="      Date: "_$$GET1^DIQ(2005.1,IEN,30.1,"E")
- . Q
- S M40=$G(^MAG(2005,IEN,40)),T=$P(M40,"^",3)
- S Z=$P($G(^MAG(2005,IEN,0)),"^",10) I Z D
- . S CT=CT+1,MAGRY(CT)=" is in Group#: "_Z_"  ("_+$P(^MAG(2005,Z,1,0),"^",4)_" images)"
- . D CHK^MAGGSQI(.QACHK,Z) Q:QACHK(0) 
- . S CT=CT+1,MAGRY(CT)=" QA Warning - Group#: "_Z_" "_$P(QACHK(0),"^",2)
- . Q
- S OBJTYP=$P(^MAG(2005,IEN,0),"^",6)
- S SNGRP="FLDS"
- I (+$O(^MAG(2005,IEN,1,0)))!(OBJTYP=11)!(OBJTYP=16) D
- . S CT=CT+1,MAGRY(CT)=$P($G(^MAG(2005,IEN,40)),"^",1)_" Group of "_+$P($G(^MAG(2005,IEN,1,0)),U,4)
- . S SNGRP="FLDG"
- . Q
- K QACHK
- D CHK^MAGGSQI(.QACHK,IEN) I 'QACHK(0) D
- . S CT=CT+1,MAGRY(CT)=" QA Warning - Image#: "_IEN_" "_$P(QACHK(0),"^",2)
- N MAGOUT,MAGERR,MAGVAL,PKG
- S IENC=IEN_","
- S FLAGS="EN"
- S I=-1
- S PKG=""
- F  S I=I+1,Z=$T(@SNGRP+I) Q:$P(Z,";",3)="end"  D
- . S J=$P(Z,";",4),JI=J_";"
- . K MAGOUT
- . S CT=CT+1,MAGRY(CT)=$P(Z,";",3)
- . I J=41 D  Q  ; Need to compute the Class.  Class field in Image File is wrong.
- . . S MAGVAL=$S('T:"",'$D(^MAG(2005.83,T,0)):"",1:$P(^MAG(2005.82,$P(^MAG(2005.83,T,0),"^",2),0),"^",1))
- . . S MAGRY(CT)=MAGRY(CT)_" "_MAGVAL
- . . Q
- . D GETS^DIQ(2005,IEN,JI,FLAGS,"MAGOUT","MAGERR")
- . ; Get Extension from FileRef
- . I J=1 S MAGVAL=$P($G(MAGOUT(2005,IENC,J,"E")),".",2)
- . E  S MAGVAL=$G(MAGOUT(2005,IENC,J,"E"))
- . S MAGVAL=$TR(MAGVAL,"&","+")
- . I J=40 S PKG=MAGVAL
- . I ((J>=50)&(J<=54)) D  Q
- . . I PKG'="LAB" K MAGRY(CT) Q
- . . S MAGRY(CT)=MAGRY(CT)_" "_MAGVAL
- . . Q
- . S MAGRY(CT)=MAGRY(CT)_" "_MAGVAL
- ; Compare Parent Association Date with Date/Time Note Signed.
- I $P(^MAG(2005,IEN,0),"^",10) S IEN=$P(^MAG(2005,IEN,0),"^",10)
- I $P(^MAG(2005,IEN,2),"^",6)=8925 S CT=CT+1,MAGRY(CT)=$$ATTSTAT^MAGGTU31(IEN)
- ;
- I (OBJTYP=11),($P($G(^MAG(2005,IEN,100)),"^",6)="") D
- . S X=$O(^MAG(2005,IEN,1,0))
- . S IEN=+$G(^MAG(2005,IEN,1,X,0))
- . Q
- I $P($G(^MAG(2005,IEN,100)),"^",6)]"" D
- . I OBJTYP=11 D  ; If a Group, get Object Type of First Child
- . . S Z=$O(^MAG(2005,IEN,1,0))
- . . I 'Z Q
- . . S Z=+$G(^MAG(2005,IEN,1,Z,0))
- . . S OBJTYP=+$P($G(^MAG(2005,Z,0)),"^",6) ; Object of First Child
- . . Q
- . S OBJTYP=","_OBJTYP_","
- . S LBL="",VAL=""
- . I ",3,9,10,12,100,"[OBJTYP S LBL="Image Creation Date: "           ; "Acquisition Date";
- . I ",15,101,102,103,104,105,"[OBJTYP S LBL="Document Creation Date: "
- . I LBL="" S LBL="Image Creation Date: "
- . S VAL=$$GET1^DIQ(2005,IEN,110,"E") S:(VAL="") VAL="N/A"
- . S CT=CT+1,MAGRY(CT)=LBL_VAL
- . Q
- Q
- ;
-FLDS ;;Format:       ;3;;
- ;;Extension:    ;1;;
-FLDG ;;Patient:      ;5;;
- ;;Desc:         ;10;;
- ;;Procedure:    ;6;;
- ;;     Date:    ;15;;
- ;;Class:        ;41;;
- ;;Package:      ;40;;
- ;;Type:         ;42;;
- ;;Proc/Event:   ;43;;
- ;;Spec/SubSpec: ;44;;
- ;;Origin:       ;45;;
- ;;Accession #   ;50;;
- ;;Specimen Desc ;51;;
- ;;Specimen#     ;52;;
- ;;Stain         ;53;;
- ;;Objective     ;54;;
- ;;Captured on:  ;7;;
- ;;         by:  ;8;;
- ;;end;;
Index: FOIAVistA/tag/r/IMAGING-MAG-ZMAG/MAGGTU4.m
===================================================================
--- FOIAVistA/trunk/r/IMAGING-MAG-ZMAG/MAGGTU4.m	(revision 631)
+++ FOIAVistA/tag/r/IMAGING-MAG-ZMAG/MAGGTU4.m	(revision 636)
@@ -1,5 +1,5 @@
-MAGGTU4 ;WOIFO/GEK - Imaging Client- Version checking routine; [ 06/20/2001 08:57 ]
- ;;3.0;IMAGING;**8,48,63,45,46,59,96**;April 29, 2008;Build 9
- ;;Per VHA Directive 2004-038, this routine should not be modified.
+MAGGTU4 ;WOIFO/GEK - Testing callbacks for Delphi Doc Image Prototype ; 02/16/2007 13:37
+ ;;3.0;IMAGING;**8,48,63,45,46**;16-February-2007;;Build 1023
+ ;; Per VHA Directive 2004-038, this routine should not be modified.
  ;; +---------------------------------------------------------------+
  ;; | Property of the US Government.                                |
@@ -22,6 +22,6 @@
  ; The Server Version SVRVER needs hardcoded to match the Delphi Client.
  ; and This Routine must be distributed whenever a new Client is
- S SVRVER="3.0.96"
- S SVRTVER="4" ; This is the T version that the server expects
+ S SVRVER="3.0.46"
+ S SVRTVER=28 ; This is the T version that the server expects
  ; released Client will have the T version that the server expects
  S A("3.0.24")=5         ;Sept 2003
@@ -32,15 +32,10 @@
  S A("3.0.63")=4         ;June 2005
  S A("3.0.45")=8         ;Sept 2005
- S A("3.0.46")=28        ;Mar  2007
- S A("3.0.59")=31        ;Jul  2007
- S A("3.0.72")=21        ;Jan  2008
- S A("3.0.83")=24        ;Mar  2008
- S A("3.0.95")=5         ;Mar  2008
- S A("3.0.96")=4         ;Apr  2008
+ S A("3.0.59")=20        ;July 2006
  Q
  ;
 CHKVER(MAGRY,CLVER) ;RPC [MAG4 VERSION CHECK]
  ; CLVER is the version of the Delphi Client.
- ; CLVER format = Major.Minor.Patch.T-version
+ ; CLVER format = Major,Minor,Patch,T Version
  ; example : for Version 3.0 Patch 8 T 21 -->  CLVER=3.0.8.21
  ; Ver 2.5P9 (2.5.24.1) is first Delphi Ver that makes this call.
@@ -60,5 +55,5 @@
  I $P(CLVER,".",1)="30" S CLVER="3.0."_$P(CLVER,".",3,99)
  ;
- N PLC,SV,ST,SVSTAT,CV,CP,CT,OKVER,WARN,I,BETA
+ N PLC,SV,ST,SVSTAT,CV,CP,CT,OKVER,WARN,I
  ; PLC = Entry in 2006.1
  ; SV = Server Version -> (3.0.8) from (3.0.8.43) Hard coded to Sync with Delphi Clients
@@ -93,9 +88,8 @@
  D VERSTAT(.SVSTAT,SV)
  I 'SVSTAT S MAGRY(0)="2^"_$P(SVSTAT,"^",2) Q  ; There is not record of a KIDS for this Server.
- ; Set Alpha Beta Flag
- S BETA=(+SVSTAT=2)
+ ; 
  ;      If Client isn't one of the Supported Clients.
  I (CV'=SV),'$D(OKVER(CV)) D  Q
- . I BETA D NOTOKB^MAGGTU41(.MAGRY) Q
+ . I +SVSTAT=2 D NOTOKB^MAGGTU41(.MAGRY) Q
  . D NOTOK^MAGGTU41(.MAGRY) Q
  . Q 
@@ -104,8 +98,8 @@
  I (CV'=SV) D  Q
  . I CT<$G(OKVER(CV)) D  Q
- . . I BETA DO OKBADTB^MAGGTU41(.MAGRY) Q
+ . . I +SVSTAT=2 DO OKBADTB^MAGGTU41(.MAGRY) Q
  . . DO OKBADT^MAGGTU41(.MAGRY) Q
  . . Q
- . I BETA D OKB^MAGGTU41(.MAGRY)
+ . I +SVSTAT=2 D OKB^MAGGTU41(.MAGRY)
  . E  D OK^MAGGTU41(.MAGRY)
  . I WARN D WARNING
@@ -114,5 +108,5 @@
  ; At this point, Versions are the Same: If T versions are not, warn the Client.
  I CT,(CT'=ST) D  Q
- . I BETA D TNOTOKB^MAGGTU41(.MAGRY) Q
+ . I +SVSTAT=2 D TNOTOKB^MAGGTU41(.MAGRY) Q
  . D TNOTOK^MAGGTU41(.MAGRY) Q
  . Q
@@ -125,5 +119,4 @@
  ;
 NEEDWARN(WARN) ; This call determines if Client needs the warning.
- S WARN=0 Q  ; we don't need warning anymore.
  I $P($G(^MAG(2006.1,PLC,"USERPREF")),U,2)="" S WARN=0 Q  ; Not a MUSE Site.
  I $D(MAGJOB("CAPTURE")) S WARN=0 Q  ;Not needed for Capture Clients
@@ -173,6 +166,6 @@
  N VERI,TVER,MAGERR
  I +MAGVER S MAGVER="MAG*"_$P(MAGVER,".",1,2)_"*"_$P(MAGVER,".",3)
- S VERI=$$FIND1^DIC(9.6,"","MO",MAGVER,"","","MAGERR")
- I 'VERI S MAGRY="0^There is No KIDs Install record for """_MAGVER_"""." Q
+ S VERI=$$FIND1^DIC(9.6,"","M",MAGVER,"","","MAGERR")
+ I 'VERI S MAGRY="0^There is No KIDs Install record." Q
  S TVER=$$GET1^DIQ(9.6,VERI_",","ALPHA/BETA TESTING")
  I TVER="YES" S MAGRY="2^Alpha/Beta Version." Q
Index: FOIAVistA/tag/r/IMAGING-MAG-ZMAG/MAGGTU41.m
===================================================================
--- FOIAVistA/trunk/r/IMAGING-MAG-ZMAG/MAGGTU41.m	(revision 631)
+++ FOIAVistA/tag/r/IMAGING-MAG-ZMAG/MAGGTU41.m	(revision 636)
@@ -1,4 +1,4 @@
 MAGGTU41 ;WOIFO/GEK - Version Control utilities  ; [ 06/20/2001 08:57 ]
- ;;3.0;IMAGING;**46,59**;Nov 27, 2007;Build 20
+ ;;3.0;IMAGING;**46**;16-February-2007;;Build 1023
  ;; Per VHA Directive 2004-038, this routine should not be modified.
  ;; +---------------------------------------------------------------+
@@ -9,5 +9,4 @@
  ;; | Development Office of the Department of Veterans Affairs,     |
  ;; | telephone (301) 734-0100.                                     |
- ;; |                                                               |
  ;; | The Food and Drug Administration classifies this software as  |
  ;; | a medical device.  As such, it may not be changed in any way. |
@@ -45,5 +44,5 @@
  I $P(CV,".",1)=2 S X(50)="(clicking 'Cancel' will not stop the Abort.)"
  Q
-OKBADTB(X) ; Client not Equal, Is supported. Previous Supported Version. Beta
+OKBADTB(X) ; Client not Equal, but it is supported.
  ;  But it's T isn't the T of it's Released Patch
  S X(0)="0^   Server is running Imaging V. "_SV_"      "_$P(SVSTAT,"^",2)
@@ -59,5 +58,5 @@
  S X(30)="                          APPLICATION will Continue  "
  Q
-OKBADT(X) ; Client not Equal, but it is supported.  Previous Supported Version
+OKBADT(X) ; Client not Equal, but it is supported.
  ;  But it's T isn't the T of it's Released Patch
  S X(0)="2^   Server is running Imaging V. "_SV_"      "_$P(SVSTAT,"^",2)
Index: FOIAVistA/tag/r/IMAGING-MAG-ZMAG/MAGGTU6.m
===================================================================
--- FOIAVistA/trunk/r/IMAGING-MAG-ZMAG/MAGGTU6.m	(revision 631)
+++ FOIAVistA/tag/r/IMAGING-MAG-ZMAG/MAGGTU6.m	(revision 636)
@@ -1,4 +1,4 @@
-MAGGTU6 ;WOIFO/GEK - Silent Utilities ; [ 06/20/2001 08:57 ]
- ;;3.0;IMAGING;**24,8,48,45,20,46,59**;Nov 27, 2007;Build 20
+MAGGTU6 ;WOIFO/GEK - Silent Utilities ; 25 Jan 2006  12:14 PM
+ ;;3.0;IMAGING;**24,8,48,45,20,46**;16-February-2007;;Build 1023
  ;; Per VHA Directive 2004-038, this routine should not be modified.
  ;; +---------------------------------------------------------------+
@@ -9,5 +9,4 @@
  ;; | Development Office of the Department of Veterans Affairs,     |
  ;; | telephone (301) 734-0100.                                     |
- ;; |                                                               |
  ;; | The Food and Drug Administration classifies this software as  |
  ;; | a medical device.  As such, it may not be changed in any way. |
Index: FOIAVistA/tag/r/IMAGING-MAG-ZMAG/MAGGTU71.m
===================================================================
--- FOIAVistA/trunk/r/IMAGING-MAG-ZMAG/MAGGTU71.m	(revision 631)
+++ FOIAVistA/tag/r/IMAGING-MAG-ZMAG/MAGGTU71.m	(revision 636)
@@ -1,5 +1,5 @@
 MAGGTU71 ;WOIFO/GEK - Silent calls for Queing functions from GUI, cont ;  [ 06/20/2001 08:57 ]
- ;;3.0;IMAGING;**46,59**;Nov 27, 2007;Build 20
- ;;Per VHA Directive 2004-038, this routine should not be modified.
+ ;;3.0;IMAGING;**46**;16-February-2007;;Build 1023
+ ;; Per VHA Directive 2004-038, this routine should not be modified.
  ;; +---------------------------------------------------------------+
  ;; | Property of the US Government.                                |
@@ -17,7 +17,7 @@
  ;;
  Q
-ABSJB(MAGRY,DATA) ;RPC [MAG ABSJB] SET ABSTRACT AND/OR JUKEBOX QUEUES
+ABSJB(MAGRY,MAGIN) ;RPC [MAG ABSJB] SET ABSTRACT AND/OR JUKEBOX QUEUES
  ;
- ;       DATA
+ ;       MAGIN
  ;   DESCRIPTION:  '^' delimited String:
  ;   Piece 1 = the IEN of the image that needs an abstract created.
@@ -31,5 +31,5 @@
  N $ETRAP,$ESTACK S $ETRAP="D ERR^"_$T(+0)
  S MAGRY="0^ERROR: Setting Queue for Abstract or JukeBox copy"
- S MAGIENAB=+$P(DATA,"^",1),MAGIENJB=+$P(DATA,"^",2)
+ S MAGIENAB=+$P(MAGIN,"^",1),MAGIENJB=+$P(MAGIN,"^",2)
  I MAGIENAB Q:((+$P($G(^MAG(2005,MAGIENAB,0)),U,11))!(+$P($G(^MAG(2005,MAGIENAB,0)),U,12))) "0^Image integrity"
  I MAGIENJB Q:((+$P($G(^MAG(2005,MAGIENJB,0)),U,11))!(+$P($G(^MAG(2005,MAGIENJB,0)),U,12))) "0^Image integrity"
Index: FOIAVistA/tag/r/IMAGING-MAG-ZMAG/MAGGTU9.m
===================================================================
--- FOIAVistA/trunk/r/IMAGING-MAG-ZMAG/MAGGTU9.m	(revision 631)
+++ FOIAVistA/tag/r/IMAGING-MAG-ZMAG/MAGGTU9.m	(revision 636)
@@ -1,5 +1,4 @@
 MAGGTU9 ;WOIFO/LB/GEK - Imaging utilities assign key
- ;;3.0;IMAGING;**8,59**;Nov 27, 2007;Build 20
- ;; Per VHA Directive 2004-038, this routine should not be modified.
+ ;;3.0;IMAGING;**8**;Sep 15, 2004
  ;; +---------------------------------------------------------------+
  ;; | Property of the US Government.                                |
@@ -18,101 +17,54 @@
  ;;
  Q
-CHKKEY ;
- N NOGIVE
- S NOGIVE=1
-GIVEKEY ;Give MAGDISP CLIN key to all MAG WINDOWS option holders
- ; that have neither MAGDISP CLIN nor MAGDISP ADMIN
+EN ;Give MAGDISP CLIN key to all MAG WINDOWS option holders.
  ;   Find the menu option's IEN
- N MKEYC,MKEYA,ERR,OPT,MAGUSER,I,KEYCLIN,KEYADMIN,KEYCT,KEYECT,XCT
- N KEYHASC,KEYHASA,KEYHASB,KEYNONE,SP,LSP
- N UCT,UTOT,OPTACC,MDOT,UDISCT
- ; This could be made Generic if ever a need, to search for users 
- ; withour either key, and assigned those users the first (KEYCLIN)
- S KEYCLIN="MAGDISP CLIN"
- S KEYADMIN="MAGDISP ADMIN"
+ N MKEY,ERR,OPT,MAGUSER,I,KEYNM,KEYCT,KEYECT,XCT,KEYHAS
+ N UCT,UTOT,OPTACC,MDOT
+ S KEYNM="MAGDISP CLIN"
  S KEYCT=0 ; count of number of users that were assigned the key.
  S KEYECT=0 ; count of number of errors during the assignment.
- S KEYHASC=0 ; count of number of users that already have key Clin
- S KEYHASA=0 ; count of number of users that already have key Admin
- S KEYHASB=0 ; count of number of users that Have Both keys
- S KEYNONE=0 ; count of Users that have Neither Key.
+ S KEYHAS=0 ; count of number of users that already have key.
  S OPTACC=0 ; count of users with access to MAG WINDOWS.
- S UDISCT=0 ; count of Disabled Users Skipped.
  S MDOT=10000 ; print '.' to screen to show progress.
  S UCT=0 ; user count. for progress
  S UTOT=$P(^VA(200,0),"^",4)
- ;
- I $G(NOGIVE) D 
- . D MES^XPDUTL("Checking for users that have access to Option : "_"MAG WINDOWS")
- . D MES^XPDUTL("  but do not have either '"_KEYCLIN_"' or '"_KEYADMIN_"' Keys")
- . D MES^XPDUTL("  Disabled users (DISUSER=1) are skipped, they are not checked.")
- . Q
- E  D MES^XPDUTL("Assigning "_KEYCLIN_" to all users with access to Option : "_"MAG WINDOWS")
- D MES^XPDUTL("  ")
+ ; 
+ D MES^XPDUTL("Assigning "_KEYNM_" to all users with access to Option : "_"MAG WINDOWS")
  S OPT=$$FIND1^DIC(19,"","X","MAG WINDOWS","","","ERR")
  I OPT="" D MES^XPDUTL("ERROR ",$G(ERR("DIERR",1,"TEXT",1))) Q
  I OPT=0 D MES^XPDUTL("MAG WINDOWS wasn't found in Option File") Q
  ;   Lookup the security key
- S MKEYC=$$LKUP^XPDKEY(KEYCLIN)
- S MKEYA=$$LKUP^XPDKEY(KEYADMIN)
- I ('MKEYC)!('MKEYA) D MES^XPDUTL("ERROR: Imaging Display Keys are not defined at this site") Q
- ;   Check all Users at site to see if they don't have either Clin or Admin
+ S MKEY=$$LKUP^XPDKEY(KEYNM)
+ I 'MKEY D MES^XPDUTL("ERROR "_KEYNM_" Key wasn't found") Q
+ ;   Give users the Key, if they don't have it already
  D MES^XPDUTL("Checking users...")
- D MES^XPDUTL(" ")
  S I=0 F  S I=$O(^VA(200,I)) Q:'I  D
- . I $$GET1^DIQ(200,I,7,"E")]"" S UDISCT=UDISCT+1 Q
  . S UCT=UCT+1 I UCT>MDOT S MDOT=MDOT+10000 D MES^XPDUTL(UCT_" of "_UTOT_" users checked...")
- . I (($$ACCESS^XQCHK(I,OPT))>0) S OPTACC=OPTACC+1 D C(I)
+ . I (($$ACCESS^XQCHK(I,OPT))>0) S OPTACC=OPTACC+1 D GIVEKEY(MKEY,KEYNM,I)
  . Q
- S SP="          "
- S LSP=$L(UTOT)+3
- D MES^XPDUTL("   ")
- I $G(NOGIVE) D
- . D MES^XPDUTL($E(SP,1,LSP-$L(OPTACC))_OPTACC_" of "_UTOT_" Users have access to option MAG WINDOWS.")
- . D MES^XPDUTL($E(SP,1,LSP-$L(KEYHASB))_KEYHASB_" Users have Both Keys ")
- . D MES^XPDUTL($E(SP,1,LSP-$L(KEYHASC))_KEYHASC_" Users only have "_KEYCLIN_" key")
- . D MES^XPDUTL($E(SP,1,LSP-$L(KEYHASA))_KEYHASA_" Users only have "_KEYADMIN_" key")
- . D MES^XPDUTL($E(SP,1,LSP-$L(KEYNONE))_KEYNONE_" Users have neither Key")
- . I KEYECT>0 D MES^XPDUTL(KEYECT_" Errors during Key Assignment. See install log for details")
- . Q
- I '$G(NOGIVE) D
- . D MES^XPDUTL($E(SP,1,LSP-$L(OPTACC))_OPTACC_" of "_UTOT_" Users have access to option MAG WINDOWS.")
- . D MES^XPDUTL($E(SP,1,LSP-$L(KEYHASB))_KEYHASB_" Users already have Both Keys ")
- . D MES^XPDUTL($E(SP,1,LSP-$L(KEYHASC))_KEYHASC_" Users have Only Key "_KEYCLIN)
- . D MES^XPDUTL($E(SP,1,LSP-$L(KEYHASA))_KEYHASA_" Users have Only Key "_KEYADMIN)
- . D MES^XPDUTL($E(SP,1,LSP-$L(KEYCT))_KEYCT_" Users were assigned key: "_KEYCLIN)
- . D MES^XPDUTL("Assignment Complete.")
- . I KEYECT>0 D MES^XPDUTL(KEYECT_" Errors during Key Assignment. See install log for details")
- . Q
+ D MES^XPDUTL(OPTACC_" of "_UTOT_" Users have access to option MAG WINDOWS.")
+ D MES^XPDUTL(KEYHAS_" Users already have Key "_KEYNM)
+ D MES^XPDUTL(KEYCT_" Users were assigned key: "_KEYNM)
+ D MES^XPDUTL("Assignment Complete.")
+ I KEYECT>0 D MES^XPDUTL(KEYECT_" Errors during Key Assignment. See install log for details")
  Q
-C(USER) ;
- ; check KEY for USER
- N DO,D1,MFDA,ZC,ZA,MIEN
- ; check to see if they have the Clin key
- S ZC=$$FIND1^DIC(200.051,","_USER_",","",KEYCLIN)
- I ZC="" D  Q
- . D MES^XPDUTL("ERROR Validating that user ("_USER_") has Key "_KEYCLIN)
+GIVEKEY(KEY,KEYNM,USER) ;
+ ; Give KEY to USER
+ N DO,D1,MFDA,Z,MIEN
+ ; Quit if they already have the key
+ S Z=$$FIND1^DIC(200.051,","_USER_",","",KEYNM)
+ I +Z S KEYHAS=KEYHAS+1
+ Q:Z  ; Already have key
+ I Z="" D  Q
+ . D MES^XPDUTL("ERROR Validating that user ("_USER_") has key ("_KEYNM_")")
  . S KEYECT=KEYECT+1
- . Q
- ; check to see if they have the Admin key
- S ZA=$$FIND1^DIC(200.051,","_USER_",","",KEYADMIN)
- I ZA="" D  Q
- . D MES^XPDUTL("ERROR Validating that user ("_USER_") has Key "_KEYADMIN)
- . S KEYECT=KEYECT+1
- . Q
- I ((+ZC)&(+ZA)) S KEYHASB=KEYHASB+1 Q
- I +ZC S KEYHASC=KEYHASC+1 Q
- I +ZA S KEYHASA=KEYHASA+1 Q
- S KEYNONE=KEYNONE+1
- I $G(NOGIVE) D  Q
- . D MES^XPDUTL("User: "_$P($G(^VA(200,USER,0)),"^")_" has neither Key")
- . Q
- S MFDA(200.051,"+1,"_USER_",",.01)=MKEYC
+ ;
+ S MFDA(200.051,"+1,"_USER_",",.01)=KEY
  S MFDA(200.051,"+1,"_USER_",",1)=DUZ
  S MFDA(200.051,"+1,"_USER_",",2)=DT
- S MIEN(1)=MKEYC_","
+ S MIEN(1)=KEY_","
  D UPDATE^DIE("","MFDA","MIEN")
  I $D(DIERR) D  Q
- . D MES^XPDUTL("ERROR Assigning Key ("_KEYCLIN_") to user ("_USER_")")
+ . D MES^XPDUTL("ERROR Assigning key ("_KEYNM_") to user ("_USER_")")
  . S KEYECT=KEYECT+1
  . D CLEAN^DILF
Index: FOIAVistA/tag/r/IMAGING-MAG-ZMAG/MAGGTUP.m
===================================================================
--- FOIAVistA/trunk/r/IMAGING-MAG-ZMAG/MAGGTUP.m	(revision 631)
+++ FOIAVistA/tag/r/IMAGING-MAG-ZMAG/MAGGTUP.m	(revision 636)
@@ -1,5 +1,4 @@
 MAGGTUP ;WOIFO/GEK - Imaging System User preferences ; [ 06/20/2001 08:57 ]
- ;;3.0;IMAGING;**7,8,48,45,59**;Nov 27, 2007;Build 20
- ;;Per VHA Directive 2004-038, this routine should not be modified.
+ ;;3.0;IMAGING;**7,8,48,45**;Sep 12, 2005
  ;; +---------------------------------------------------------------+
  ;; | Property of the US Government.                                |
@@ -116,9 +115,7 @@
  S ARR($J,"GROUP")="2^24^231^427^457^110^70^^1^2^24^2^1^0"
  S ARR($J,"DOC")="2^298^24^729^429^0^0^3^1^2^4^2^0"
- S ARR($J,"CAPCONFIG")="1^1^1^0^0^0^0^1^0^1^0^0^1^1^0^0^1^1^1^1^1^1^200^400^300^100^500^0^0^1^0^1"
- ;                    1   2   3   4   5  6  7  8 9 0 1  2   3  456 7 8
- S ARR($J,"CAPTIU")="261^414^455^654^66^67^280^1^1^~^1^100^-12^^^1^1^^"
+ S ARR($J,"CAPCONFIG")="1^1^1^0^0^0^0^1^0^1^0^0^1^1^0^0^1^1^1^1^1^1^200^400^300^100^500^0^0^1^"
+ S ARR($J,"CAPTIU")="5^369^760^654^289^67^170^1^1^"
  S ARR($J,"RIVER")="1^0^0^0^"
- S ARR($J,"APPMSG")="0^0^"
  S ARR($J,"APPPREFS")="1^7^7^10"
  S ARR($J,"LISTWIN1")="1^1^^1^1"
Index: FOIAVistA/tag/r/IMAGING-MAG-ZMAG/MAGJEX1B.m
===================================================================
--- FOIAVistA/trunk/r/IMAGING-MAG-ZMAG/MAGJEX1B.m	(revision 631)
+++ FOIAVistA/tag/r/IMAGING-MAG-ZMAG/MAGJEX1B.m	(revision 636)
@@ -1,4 +1,4 @@
 MAGJEX1B ;WIRMFO/JHC Rad. Workstation RPC calls ; 29 Jul 2003  9:58 AM
- ;;3.0;IMAGING;**16,22,18,65,76**;Jun 22, 2007;Build 19
+ ;;3.0;IMAGING;**16,22,18,65**;Jul 27, 2006;Build 28
  ;;Per VHA Directive 2004-038, this routine should not be modified.
  ;; +---------------------------------------------------------------+
@@ -115,5 +115,5 @@
  . D LOCKOUT^MAGJEX1A(RARPT,DAYCASE,.LOCKLEV,.MYLOCK,ACTION,.RESULT) ; 1st, lock to me
  . K LOCKLEV,MYLOCK D LOCKACT^MAGJEX1A(RARPT,DAYCASE,101,.RESULT) ;    then, clear the lock
- S TS="" F I=2,0 S TS=TS_$S(TS="":"",1:U)_$$HTFM^XLFDT($H+I,0)
+ S TS="" F I=2,0 S %H=$H+I D YMD^%DTC S TS=TS_$S(TS="":"",1:U)_X
  S ^XTMP("MAGJ",0)=TS_U_"VistaRad Locks"
  Q
Index: FOIAVistA/tag/r/IMAGING-MAG-ZMAG/MAGJEX2.m
===================================================================
--- FOIAVistA/trunk/r/IMAGING-MAG-ZMAG/MAGJEX2.m	(revision 631)
+++ FOIAVistA/tag/r/IMAGING-MAG-ZMAG/MAGJEX2.m	(revision 636)
@@ -1,5 +1,4 @@
 MAGJEX2 ;;WIRMFO/JHC Rad. Workstation RPC calls;[ 02/25/2000  4:40 PM ] ; 09 Jun 2003  2:58 PM
- ;;3.0;IMAGING;**51,18,76**;Jun 22, 2007;Build 19
- ;;Per VHA Directive 2004-038, this routine should not be modified.
+ ;;3.0;IMAGING;**51,18**;Mar 07, 2006
  ;; +---------------------------------------------------------------+
  ;; | Property of the US Government.                                |
@@ -87,5 +86,5 @@
  S X=$G(^MAG(2006.69,1,0))
  S LIMYRS=+$P(X,U,14),LIMEXAMS=+$P(X,U,15)
- S:'LIMYRS LIMYRS=7 S:'LIMEXAMS LIMEXAMS=50 ; default limit # Exams
+ S:'LIMYRS LIMYRS=10 S:'LIMEXAMS LIMEXAMS=100 ; default limit # Exams
  S BEGDT=($E(DT,1,3)-LIMYRS)_$E(DT,4,7)
  I BEGDT<2950101 S BEGDT=2950101 ; 2 yrs prior to earliest VistaPACS
@@ -137,9 +136,9 @@
  ;
  Q:'MAGMATCH
- ; 1  RADFN   RADTI    RACNI   RANME   RASSN    <-- from GETEXAM
- ; 6  RADATE  RADTE    RACN    RAPRC   RARPT
- ; 11 RAST    DAYCASE  RAELOC  RASTP   RASTORD
- ; 16 RADTPRT RACPT    RAIMGTYP
- S MAGDTH=$$FMTH^XLFDT($P(RADATA,U,7),1)
+   ; 1  RADFN   RADTI    RACNI   RANME   RASSN    <-- from GETEXAM
+   ; 6  RADATE  RADTE    RACN    RAPRC   RARPT
+   ; 11 RAST    DAYCASE  RAELOC  RASTP   RASTORD
+   ; 16 RADTPRT RACPT    RAIMGTYP
+ S X=$P(RADATA,U,7) D H^%DTC S MAGDTH=+%H
  S X=$P(RADATA,U,18)
  S RAIMGTYP=$S(X]"":$O(^RA(79.2,"C",X,"")),1:X)
Index: FOIAVistA/tag/r/IMAGING-MAG-ZMAG/MAGJLS2.m
===================================================================
--- FOIAVistA/trunk/r/IMAGING-MAG-ZMAG/MAGJLS2.m	(revision 631)
+++ FOIAVistA/tag/r/IMAGING-MAG-ZMAG/MAGJLS2.m	(revision 636)
@@ -1,5 +1,4 @@
 MAGJLS2 ;WIRMFO/JHC Rad. Workstation RPC calls ; 29 Jul 2003  9:58 AM
- ;;3.0;IMAGING;**22,18,76**;Jun 22, 2007;Build 19
- ;;Per VHA Directive 2004-038, this routine should not be modified.
+ ;;3.0;IMAGING;**22,18**;Mar 07, 2006
  ;; +---------------------------------------------------------------+
  ;; | Property of the US Government.                                |
@@ -19,5 +18,5 @@
  Q
  ;  ACTIVE -- list exams (Unread, Recent, &/or Pending) for input Imaging Type(s)
- ;    RPC Call: MAGJ RADACTIVEEXAMS
+ ;       RPC Call: MAGJ RADACTIVEEXAMS
  ;  BKGND -- EP for Bkgnd Compile of UNREAD list
  ;  BKGND2 -- EP for Bkgnd Compile of RECENT list
@@ -39,5 +38,4 @@
  S X=$P(DATA,U) D PARAMS^MAGJLS2B(X)
  I 'LSTID S MAGGRY=$NA(^TMP($J,"RET")),@MAGGRY@(0)="0^4~Problem with Exams List Compile--"_DATA_"." Q
- I MAGJOB("P32"),+$G(MAGJOB("P32STOP")) S MAGGRY=$NA(^TMP($J,"RET")),@MAGGRY@(0)="0^4~VistARad Patch 32 is no longer supported.  Contact Imaging support for the current version of the VistARad client software." Q  ; <*>
  I BKGND,LSTREQ="U" D BKREQU Q  ; UNREAD in bkgnd
  I BKGND,LSTREQ="R" D BKREQR Q  ; RECENT in bkgnd
@@ -89,5 +87,4 @@
  I +$G(COMPFAIL) S MAGGRY=$NA(^TMP($J,"RET")),@MAGGRY@(0)="0^4~Unable to Compile Unread Exams list"
  E  D LSTOUT^MAGJLS2B(.MAGGRY,LSTID,$NA(^XTMP("MAGJ2",LSTNAM,LSTNUM)),LSTAGE)
- K LSTAGE
  Q
  ;
@@ -100,5 +97,4 @@
  I 'LSTNUM S MAGGRY=$NA(^TMP($J,"RET")),@MAGGRY@(0)="0^4~Problem with "_LSTNM_" List Compile program (age="_LSTAGE_" for "_LSTNAM_")"_$S(LSTNAM["9992":"--May need to Schedule RECENT List Compile in TaskMan.",1:"")
  E  D LSTOUT^MAGJLS2B(.MAGGRY,LSTID,$NA(^XTMP("MAGJ2",LSTNAM,LSTNUM)),LSTAGE)
- K LSTAGE
  Q
  ;
@@ -117,5 +113,4 @@
  . D LSTOUT^MAGJLS2B(.MAGGRY,LSTID,$NA(^TMP($J,"MAGJ")))
  I 'ALLGO S MAGGRY=$NA(^TMP($J,"RET")),@MAGGRY@(0)="0^4~Problem with ALL Exams List Compile "_DATA_". "_REPLY
- K LSTAGE
  Q
  ;
@@ -151,25 +146,33 @@
  D LSTCOMP()
  I LSTREQ="R" D NEWINT
- I LSTREQ="U" D UPDR^MAGJLS2B G BKLOOP  ;UNREAD loops; RECENT uses TaskMan
+ I LSTREQ="U" D UPDR G BKLOOP  ;UNREAD loops; RECENT uses TaskMan
 BKGNDZ I LSTREQ="U" L -^XTMP("MAGJ2","BKGND2","RUN")
  N ZTREQ S ZTREQ="@"  ;  clean up task entry
- K BKLOOP,DELTA,LSTAGE
+ K BKLOOP,DELTA
  Q  ; Exit bkgnd
  ;
-NEWINT ; Add exams newly Interp since Recent Compile started to Recent List
- ; 1st, get list of candidates:
+UPDR ; Add Newly Interp exams to Recent
+ D PARAMS^MAGJLS2B(9995)
+ I 'LSTID G UPDRZ
+ S X=$$CURLIST(LSTNAM),LSTAGE=$P(X,U,2),LSTNUM=+X
+ D LSTCOMP()
+UPDRZ Q  ;
+ ;
+NEWINT ; Exams newly Interp since Recent Compile started
+ ; are added to Recent List (add to "RECENT" index)
+ ; 1st, get list of all potential candidates:
  N INDX L +^XTMP("MAGJ2","RECENT"):15
  E  Q
  S INDX=+$G(^TMP($J,"NEWINT")) ; counter when Recent Compile started
  I INDX S INDX=INDX-1 F  S INDX=$O(^XTMP("MAGJ2","RECENT",INDX)) Q:'INDX  S X=^(INDX) I X S ^TMP($J,"NEWINT",0,INDX)=X
- K ^XTMP("MAGJ2","RECENT") S ^("RECENT",0)=0
+ K ^XTMP("MAGJ2","RECENT") S ^("RECENT",0)=0 ; init this index
  L -^XTMP("MAGJ2","RECENT")
- ;if not in Recent Compile, add to index
+ ;find those not included in Recent Compile, and add to index
  S INDX=""
  F  S INDX=$O(^TMP($J,"NEWINT",0,INDX)) Q:'INDX  S X=^(INDX) D
- . I $D(^TMP($J,"NEWINT",$P(X,U,1,3))) Q  ; already there
+ . I $D(^TMP($J,"NEWINT",$P(X,U,1,3))) Q  ; already in the compile
  . L +^XTMP("MAGJ2","RECENT"):15
  . E  Q
- . S I=+$G(^XTMP("MAGJ2","RECENT",0))+1,$P(^(0),U)=I,^(I)=X ;add 
+ . S I=+$G(^XTMP("MAGJ2","RECENT",0))+1,$P(^(0),U)=I,^(I)=X ; add to indx
  . L -^XTMP("MAGJ2","RECENT")
  K ^TMP($J,"NEWINT")
@@ -178,9 +181,9 @@
 LSTCOMP(COMPFAIL) ; Compile new list; subrtn used by Active and Bkgnd tags
  S COMPFAIL=0 ; Return T/F for "Executed a List Compile?"
- L +^XTMP("MAGJ2","BKGND",LSTNAM,"COMPILE"):60
+ L +^XTMP("MAGJ2","BKGND",LSTNAM,"COMPILE"):60 ; shouldn't need any time
  E  S COMPFAIL=1 G LSTCOMZ
- S NEWLIST=$S(LSTNUM=1:2,1:1) ; toggle node to use
+ S NEWLIST=$S(LSTNUM=1:2,1:1) ; toggle node to use for new compile
  N TS,COMTIM
- S TS="" F I=2,0 S TS=TS_$S(TS="":"",1:U)_$$HTFM^XLFDT($H+I,0)
+ S TS="" F I=2,0 S %H=$H+I D YMD^%DTC S TS=TS_$S(TS="":"",1:U)_X
  S ^XTMP("MAGJ2",0)=TS_U_"VistaRad List Compile"
  S ^XTMP("MAGJ2",0,LSTNAM,NEWLIST)=$H
@@ -194,5 +197,7 @@
 LSTCOMZ L -^XTMP("MAGJ2","BKGND",LSTNAM,"COMPILE")
  Q  ;
-CURLIST(LSTNAM,WAIT) ; return cur. list & age in secs
+ ;
+CURLIST(LSTNAM,WAIT) ; return current list & its age in seconds
+ ;
  S WAIT=+$G(WAIT)
  N X,RET,AGE,TRY,START,EXTRATIM
@@ -204,11 +209,11 @@
 CURLISZ Q RET
  ;
-DELTA(X,Y) ; calc # secs bet 2 $h values; dflt 2nd value = now
+DELTA(X,Y) ; calc # seconds between 2 $h values; default 2nd value = now
  ; useful limit is one day
  I $G(Y)="" S Y=$H
  I +Y=+X
  E  D
- . I Y-X=1 S $P(Y,",",2)=86400+$P(Y,",",2)  ; midnight boundary
- . E  S $P(X,",",2)=0,$P(Y,",",2)=86400  ; > one day
+ . I Y-X=1 S $P(Y,",",2)=86400+$P(Y,",",2)  ; cross midnight boundary
+ . E  S $P(X,",",2)=0,$P(Y,",",2)=86400  ; more than one day
  Q ($P(Y,",",2)-$P(X,",",2))
  ;
Index: FOIAVistA/tag/r/IMAGING-MAG-ZMAG/MAGJLS2B.m
===================================================================
--- FOIAVistA/trunk/r/IMAGING-MAG-ZMAG/MAGJLS2B.m	(revision 631)
+++ FOIAVistA/tag/r/IMAGING-MAG-ZMAG/MAGJLS2B.m	(revision 636)
@@ -1,5 +1,4 @@
 MAGJLS2B ;WIRMFO/JHC VistARad RPC calls ; 29 Jul 2003  9:59 AM
- ;;3.0;IMAGING;**16,22,18,76**;Jun 22, 2007;Build 19
- ;;Per VHA Directive 2004-038, this routine should not be modified.
+ ;;3.0;IMAGING;**16,22,18**;Mar 07, 2006
  ;; +---------------------------------------------------------------+
  ;; | Property of the US Government.                                |
@@ -188,10 +187,4 @@
  Q
  ;
-UPDR ; Add Newly Interp exams to Recent; called from magjls2
- D PARAMS(9995)
- I LSTID D
- . S X=$$CURLIST^MAGJLS2(LSTNAM),LSTAGE=$P(X,U,2),LSTNUM=+X
- . D LSTCOMP^MAGJLS2()
-UPDRZ Q
+END Q  ;
  ;
-END ;
Index: FOIAVistA/tag/r/IMAGING-MAG-ZMAG/MAGJLS4.m
===================================================================
--- FOIAVistA/trunk/r/IMAGING-MAG-ZMAG/MAGJLS4.m	(revision 631)
+++ FOIAVistA/tag/r/IMAGING-MAG-ZMAG/MAGJLS4.m	(revision 636)
@@ -1,5 +1,4 @@
 MAGJLS4 ;WIRMFO/JHC VistARad RPCs--History List ; 29 Jul 2003  10:00 AM
- ;;3.0;IMAGING;**18,76**;Jun 22, 2007;Build 19
- ;;Per VHA Directive 2004-038, this routine should not be modified.
+ ;;3.0;IMAGING;**18**;Mar 07, 2006
  ;; +---------------------------------------------------------------+
  ;; | Property of the US Government.                                |
@@ -57,5 +56,5 @@
  ;
 HISTADD(DATA,TXDUZ,TXDIV) ; add records
- N IDATA,ILOOP,CT,NOGO,EXID,HISDAT,HISTIEN,MAGRACNT,TS
+ N IDATA,ILOOP,CT,NOGO,EXID,HISDAT,HISTIEN,MAGRACNT
  S IDATA="",CT=0,NOGO=0
  F ILOOP=0:1 S IDATA=$O(DATA(IDATA)) Q:IDATA=""  D
@@ -72,5 +71,5 @@
  S MAGRACNT=0 D ACTIVE^MAGJLS2(.MAGGRY,9996)
  S X=@MAGGRY@(0),X=+X_U_"1~"_$$HISTTL(TXDUZ,TXDIV),@MAGGRY@(0)=X
- S TS="" F I=2,0 S TS=TS_$S(TS="":"",1:U)_$$HTFM^XLFDT($H+I,0)
+ N TS S TS="" F I=2,0 S %H=$H+I D YMD^%DTC S TS=TS_$S(TS="":"",1:U)_X
  S ^XTMP("MAGJ2",0)=TS_U_"VistaRad List Compile"
  S REPLY=1
@@ -134,6 +133,6 @@
  . S HDATE=$P(XX2,U,13) D  Q:DELETED
  . . S DELETED=0,HDATE=$P(HDATE,"@")
- . . S X=HDATE,%DT="" D ^%DT K %DT
- . . I $$FMTH^XLFDT(Y,1)<($H-3) K ^XTMP("MAGJ2","HISTORY",TXDUZ,TXDIV,HISTIEN) S DELETED=1 Q
+ . . S X=HDATE,%DT="" D ^%DT S X=Y D H^%DTC K %DT
+ . . I %H<($H-3) K ^XTMP("MAGJ2","HISTORY",TXDUZ,TXDIV,HISTIEN) S DELETED=1 Q
  . ; <*> End of temp change
  . I RARPT,RADFN,RADTI,RACNI
